<?php

namespace Drupal\donorperfect_gift\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for the entity edit forms.
 *
 * @ingroup donorperfect_gift
 */
class GiftForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    /* @var $entity \Drupal\donorperfect_gift\Entity\Gift */
    $entity = $this->entity;
    $form = parent::buildForm($form, $form_state);
    $form['#after_build'] = ['::afterBuildForm'];
    return $form;
  }

  public function afterBuildForm(array $form, FormStateInterface $form_state) {
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $values = &$form_state->getValues();
    $entity = $this->entity;
    $status = parent::save($form, $form_state);
    if ($status == SAVED_UPDATED) {
      $message = $this->t('The gift %feed has been updated.', ['%feed' => $entity->toLink()->toString()]);
    } else {
      $message = $this->t('The gift %feed has been added.', ['%feed' => $entity->toLink()->toString()]);
    }
    \Drupal::messenger()->addMessage($message);
    $form_state->setRedirectUrl($this->entity->toUrl('canonical'));
    return $status;
  }
}
